#!/usr/bin/env bash
#
# 英和辞書の統合

ejdicdir="data/orig/ejdict/"
gene95dir="data/orig/gene95/"

# ejdic
jpdic1() { # ejdicの最初のカラムにlrを含む行を抽出
    awk '$1~/[LRlr]/' ${ejdicdir}*.txt
}

# gene95
jpdic2() { # geneの1行目にlrを含む行を抽出
    nkf -w -Lu ${gene95dir}gene.txt |    # まずは、文字コードをUTF-8と改行をUnixに
    # gene.txtは2行で1単語
    awk '
        NR%2==1 { h=$0 }
        NR%2==0 { if ( match(h, /[LRlr]/) > 0 ) printf("%s\t%s\n", h, $0) } '
}

merge_dicts() {
    {
    jpdic1
    jpdic2
    } |
    sort -k 1,1 |
    awk -F $'\t' ' # 同じ単語の意味を重複しないように結合する
        p1!=$1 { printf("\n%s", $1); p1=$1; p2="" }
        p1==$1 { if (p2 !=$2 ) printf("\t%s", $2); p2=$2 }
        END{ printf("\n") }' |
    egrep -v '^[ !-@[-`{-~]' | # 記号数値で始まる語を除去
    sed '/^[ \t]*$/d'          # 空行を除去
}

merge_dicts
#merge_dicts > lrdict1.txt

