#!/usr/bin/env bash
#
# ヨミ辞書を作る
# egrepはGNU egrepを用いることが前提 [ラ-ロ]などが

lrdict="data/lrdict0.txt"
tangokana="data/orig/kana/tangokana.html"
kata_2009="data/orig/kana/kata_2009.html"
kata_2008="data/orig/kana/kata_2008.html"
yomi0="data/inprogress/yomi/yomi0.txt"

kanadic1() {
    #curl -s http://www1.odn.ne.jp/xenom/tango.box/tangokana.html -o - |
    cat "$tangokana" | # curlを実行してファイルを取得済みなら、この行を有効にする
    nkf -w |
    pandoc -f html -t plain -o - - | #  ttt.0
    sed '/^[ \t]*$/d; /^http:/d; /^\*\*/d;' | # ttt.1
    egrep '^[[:alpha:]]+：' |
    egrep '[ァ-ヶー]+' | # ttt.2
    sed 's/：/\t/; s/[^ \tA-Za-zァ-ヶー]/_/g;' |    # この処理で[0-9])の処理が不要になる
    tr -s _ |                   # 連続する _ を1つにまとめる
    awk -F $'\t' '$1~/[LRlr]/ {
        printf("%s\t", $1);
        cdr($2);
    }
    function cdr(b, f, g, h, i, j, c0, c2) {
       c0=split(b, f, "_");
        for (i=1; i<=c0; i++) {
            if (f[i] != "") {
                c1=split(f[i], g, " ");
                for (j=1; j<=c1; j++) {
                    if (g[j] != "") {
                        h[g[j]]++;
                    }
                }
            }
        }
        i=0
        for (w in h) {
            if (match(w,/[ァ-ヶー]+/)>0) {
                if (i>0)
                    printf("\t%s", w);
                else
                    printf("%s", w);
                i++;
            }
        }
        printf("\n");
    }
    ' # k1.txt
}

kanadic2() { # 最新版 http://www7a.biglobe.ne.jp/nifongo/data/kata_2009.html
    #curl -s  http://www7a.biglobe.ne.jp/nifongo/data/kata_2009.html -o - |
    #cat "$kata_2009" | # curlを実行してファイルを取得済みなら、この行を有効にする
    #curl -s http://www7a.biglobe.ne.jp/nifongo/data/kata_2008.html -o - |
    cat "$kata_2008" | # curlを実行してファイルを取得済みなら、この行を有効にする
    pandoc -f html -t plain -o - - |       
    awk 'NR>11 && NR<4030' |
    cut -b 136- |                            # ヨミカタと単語、以下の部分
    awk ' !/^[ \t]*$/ {
            yomi_e=match($0,/[A-Za-z]/);
            if (yomi_e < 1) {
                next; # 目視確認済み: 無視して問題ないデータ
                printf("%d:#%s#\n", NR, $0);
            } else {
                car=substr($0,0,RSTART-1); # ヨミ
                cdr=substr($0,RSTART);     # 単語ではじまる、残りのフィールド
                sub(/[ \t]*$/,"", car);
                sub(/[ \t]*[0-9].*$/,"", cdr);
                if ( car != ""  ) {
                    c=split(cdr, cddr, /( ; )|( \/ )/);
                    for (i=1; i<=c; i++) {
                        sub(/[ \t]+[^[:alpha:]]+$/,"",cddr[i]);
                        sub(/[^[:alpha:]]+$/,"",cddr[i]);
                        sub(/[ \t][ \t]+[^ \t]+.*$/,"",car);
                        printf("%s\t%s\n", cddr[i], car);
                    }
                }
            }
        }
    ' |
    egrep '[LRlr]' # k2.txt
}

lryomi() { # 参考:lrdict0.txt から読み辞書を作成する
    < "$lrdict" awk -F $'\t' '
        /[ァ-ヶー]+/ {
            printf("%s\t",$1);
            cdr($0);
        } 

        function cdr(b, h, i) {
            while (match(b,/[ァ-ヶー]+/)>0) {
                h[substr(b,RSTART,RLENGTH)]++;
                b=substr(b,RSTART+RLENGTH);
            }
            i=0
            for (w in h) {
                if (i>0)
                    printf("\t%s", w);
                else
                    printf("%s", w);
                i++;
            }
            printf("\n");
        }
        '
}

merge_yomi() {
    {
    #lryomi
    kanadic1
    kanadic2
    } | 
    sort -k 1,1 | uniq |
    awk -F $'\t' ' # 同じ単語の意味を重複しないように結合する
        p1!=$1 { printf("\n%s", $1); p1=$1; p2="" }
        p1==$1 { if (p2 !=$2 ) printf("\t%s", $2); p2=$2 }
        END { printf("\n") }' |
        sed '/^[ \t]*$/d'
}

merge_yomi
#merge_yomi > $yomi0
